source: installer/opengnsys_update.sh @ 3ce53a7

918-git-images-111dconfigfileconfigure-oglivegit-imageslgromero-new-oglivemainmaint-cronmount-efivarfsmultivmmultivm-ogboot-installerogClonningEngineogboot-installer-jenkinsoglive-ipv6test-python-scriptsticket-301ticket-50ticket-50-oldticket-577ticket-585ticket-611ticket-612ticket-693ticket-700ubu24tplunification2use-local-agent-oglivevarios-instalacionwebconsole3
Last change on this file since 3ce53a7 was 3ce53a7, checked in by ramon <ramongomez@…>, 14 years ago

Versión 1.0.2: preparar módulo HTTPS para el servidor Apache (modifica #443)

git-svn-id: https://opengnsys.es/svn/branches/version1.0@2328 a21b9725-9963-47de-94b9-378ad31fedc9

  • Property mode set to 100755
File size: 21.4 KB
Line 
1#!/bin/bash
2#/**
3#@file    opengnsys_update.sh
4#@brief   Script actualización de OpenGnSys
5#@warning No se actualiza BD, ni ficheros de configuración.
6#@version 0.9 - basado en opengnsys_installer.sh
7#@author  Ramón Gómez - ETSII Univ. Sevilla
8#@date    2010/01/27
9#@version 1.0 - adaptación a OpenGnSys 1.0
10#@author  Ramón Gómez - ETSII Univ. Sevilla
11#@date    2011/03/02
12#@version 1.0.1 - control de auto actualización del script
13#@author  Ramón Gómez - ETSII Univ. Sevilla
14#@date    2011/05/17
15#*/
16
17
18####  AVISO: Editar configuración de acceso por defecto a la Base de Datos.
19OPENGNSYS_DATABASE="ogAdmBD"            # Nombre de la base datos
20OPENGNSYS_DBUSER="usuog"                # Usuario de acceso
21OPENGNSYS_DBPASSWORD="passusuog"        # Clave del usuario
22
23####  AVISO: NO Editar variables de acceso desde el cliente
24OPENGNSYS_CLIENTUSER="opengnsys"        # Usuario Samba
25
26
27# Sólo ejecutable por usuario root
28if [ "$(whoami)" != 'root' ]
29then
30        echo "ERROR: this program must run under root privileges!!"
31        exit 1
32fi
33# Error si OpenGnSys no está instalado (no existe el directorio del proyecto)
34INSTALL_TARGET=/opt/opengnsys
35if [ ! -d $INSTALL_TARGET ]; then
36        echo "ERROR: OpenGnSys is not installed, cannot update!!"
37        exit 1
38fi
39
40# Comprobar si se ha descargado el paquete comprimido (USESVN=0) o sólo el instalador (USESVN=1).
41PROGRAMDIR=$(readlink -e $(dirname "$0"))
42PROGRAMNAME=$(basename "$0")
43DEPS="build-essential g++-multilib rsync ctorrent samba unzip netpipes debootstrap schroot squashfs-tools"
44OPENGNSYS_SERVER="www.opengnsys.es"
45if [ -d "$PROGRAMDIR/../installer" ]; then
46    USESVN=0
47else
48    USESVN=1
49    DEPS="$DEPS subversion"
50fi
51SVN_URL="http://$OPENGNSYS_SERVER/svn/branches/version1.0/"
52
53WORKDIR=/tmp/opengnsys_update
54mkdir -p $WORKDIR
55
56LOG_FILE=/tmp/opengnsys_update.log
57
58
59
60#####################################################################
61####### Algunas funciones útiles de propósito general:
62#####################################################################
63
64# Comprobar auto-actualización.
65function checkAutoUpdate()
66{
67        local update=0
68
69        # Actaulizar el script si ha cambiado o no existe el original.
70        if [ $USESVN -eq 1 ]; then
71                svn export $SVN_URL/installer/$PROGRAMNAME
72                if ! diff --brief $PROGRAMNAME $INSTALL_TARGET/lib/$PROGRAMNAME &>/dev/null || ! test -f $INSTALL_TARGET/lib/$PROGRAMNAME; then
73                        mv $PROGRAMNAME $INSTALL_TARGET/lib
74                        update=1
75                else
76                        rm -f $PROGRAMNAME
77                fi
78        else
79                if ! diff --brief $PROGRAMDIR/$PROGRAMNAME $INSTALL_TARGET/lib/$PROGRAMNAME &>/dev/null || ! test -f $INSTALL_TARGET/lib/$PROGRAMNAME; then
80                        cp -a $PROGRAMDIR/$PROGRAMNAME $INSTALL_TARGET/lib
81                        update=1
82                fi
83        fi
84
85        return $update
86}
87
88
89function getDateTime()
90{
91        date "+%Y%m%d-%H%M%S"
92}
93
94# Escribe a fichero y muestra por pantalla
95function echoAndLog()
96{
97        echo $1
98        DATETIME==`getDateTime`
99        echo "$DATETIME=;$SSH_CLIENT;$1" >> $LOG_FILE
100}
101
102function errorAndLog()
103{
104        echo "ERROR: $1"
105        DATETIME=`getDateTime`
106        echo "$DATETIME=;$SSH_CLIENT;ERROR: $1" >> $LOG_FILE
107}
108
109
110#####################################################################
111####### Funciones de copia de seguridad y restauración de ficheros
112#####################################################################
113
114# Hace un backup del fichero pasado por parámetro
115# deja un -last y uno para el día
116function backupFile()
117{
118        if [ $# -ne 1 ]; then
119                errorAndLog "${FUNCNAME}(): invalid number of parameters"
120                exit 1
121        fi
122
123        local fichero=$1
124        local fecha=`date +%Y%m%d`
125
126        if [ ! -f $fichero ]; then
127                errorAndLog "${FUNCNAME}(): file $fichero doesn't exists"
128                return 1
129        fi
130
131        echoAndLog "${FUNCNAME}(): Making $fichero back-up"
132
133        # realiza una copia de la última configuración como last
134        cp -p $fichero "${fichero}-LAST"
135
136        # si para el día no hay backup lo hace, sino no
137        if [ ! -f "${fichero}-${fecha}" ]; then
138                cp -p $fichero "${fichero}-${fecha}"
139        fi
140}
141
142# Restaura un fichero desde su copia de seguridad
143function restoreFile()
144{
145        if [ $# -ne 1 ]; then
146                errorAndLog "${FUNCNAME}(): invalid number of parameters"
147                exit 1
148        fi
149
150        local fichero=$1
151
152        echoAndLog "${FUNCNAME}(): restoring file $fichero"
153        if [ -f "${fichero}-LAST" ]; then
154                cp -p "$fichero-LAST" "$fichero"
155        fi
156}
157
158
159#####################################################################
160####### Funciones de acceso a base de datos
161#####################################################################
162
163# Actualizar la base datos
164function importSqlFile()
165{
166        if [ $# -ne 4 ]; then
167                errorAndLog "${FNCNAME}(): invalid number of parameters"
168                exit 1
169        fi
170
171        local dbuser="$1"
172        local dbpassword="$2"
173        local database="$3"
174        local sqlfile="$4"
175        local tmpfile=$(mktemp)
176        local status
177
178        if [ ! -r $sqlfile ]; then
179                errorAndLog "${FUNCNAME}(): Unable to read $sqlfile!!"
180                return 1
181        fi
182
183        echoAndLog "${FUNCNAME}(): importing SQL file to ${database}..."
184        chmod 600 $tmpfile
185        sed -e "s/SERVERIP/$SERVERIP/g" -e "s/DBUSER/$OPENGNSYS_DB_USER/g" \
186            -e "s/DBPASSWORD/$OPENGNSYS_DB_PASSWD/g" $sqlfile > $tmpfile
187        mysql -u$dbuser -p"$dbpassword" --default-character-set=utf8 "$database" < $tmpfile
188        status=$?
189        rm -f $tmpfile
190        if [ $status -ne 0 ]; then
191                errorAndLog "${FUNCNAME}(): error importing $sqlfile in database $database"
192                return 1
193        fi
194        echoAndLog "${FUNCNAME}(): file imported to database $database"
195        return 0
196}
197
198
199#####################################################################
200####### Funciones de instalación de paquetes
201#####################################################################
202
203# Instalar las deependencias necesarias para el actualizador.
204function installDependencies()
205{
206        if [ $# = 0 ]; then
207                echoAndLog "${FUNCNAME}(): no deps needed."
208        else
209                while [ $# -gt 0 ]; do
210                        dpkg -s $1 2>/dev/null | grep -q "Status: install ok"
211                        if [ $? -ne 0 ]; then
212                                INSTALLDEPS="$INSTALLDEPS $1"
213                        fi
214                        shift
215                done
216                if [ -n "$INSTALLDEPS" ]; then
217                        apt-get update && apt-get -y install --force-yes $INSTALLDEPS
218                        if [ $? -ne 0 ]; then
219                                errorAndLog "${FUNCNAME}(): cannot install some dependencies: $INSTALLDEPS."
220                                return 1
221                        fi
222                fi
223        fi
224}
225
226
227#####################################################################
228####### Funciones para el manejo de Subversion
229#####################################################################
230
231function svnExportCode()
232{
233        if [ $# -ne 1 ]; then
234                errorAndLog "${FUNCNAME}(): invalid number of parameters"
235                exit 1
236        fi
237
238        local url="$1"
239
240        echoAndLog "${FUNCNAME}(): downloading subversion code..."
241
242        svn checkout "${url}" opengnsys
243        if [ $? -ne 0 ]; then
244                errorAndLog "${FUNCNAME}(): error getting code from ${url}, verify your user and password"
245                return 1
246        fi
247        echoAndLog "${FUNCNAME}(): subversion code downloaded"
248        return 0
249}
250
251
252############################################################
253###  Detectar red
254############################################################
255
256# Comprobar si existe conexión.
257function checkNetworkConnection()
258{
259        OPENGNSYS_SERVER=${OPENGNSYS_SERVER:-"www.opengnsys.es"}
260        wget --spider -q $OPENGNSYS_SERVER
261}
262
263
264#####################################################################
265####### Funciones específicas de la instalación de Opengnsys
266#####################################################################
267
268# Copiar ficheros de arranque de los servicios del sistema de OpenGnSys
269function updateServicesStart()
270{
271        echoAndLog "${FUNCNAME}(): Updating OpenGnSys init file ..."
272        cp -p $WORKDIR/opengnsys/admin/Sources/Services/opengnsys.init /etc/init.d/opengnsys
273        if [ $? != 0 ]; then
274                errorAndLog "${FUNCNAME}(): Error updating /etc/init.d/opengnsys"
275                exit 1
276        fi
277        echoAndLog "${FUNCNAME}(): init file updated successfully."
278}
279
280# Actualizar cliente OpenGnSys
281function updateClientFiles()
282{
283        echoAndLog "${FUNCNAME}(): Updating OpenGnSys Client files."
284        rsync --exclude .svn -irplt $WORKDIR/opengnsys/client/shared/* $INSTALL_TARGET/client
285        if [ $? -ne 0 ]; then
286                errorAndLog "${FUNCNAME}(): error while updating client structure"
287                exit 1
288        fi
289        find $INSTALL_TARGET/client -name .svn -type d -exec rm -fr {} \; 2>/dev/null
290       
291        echoAndLog "${FUNCNAME}(): Updating OpenGnSys Cloning Engine files."
292        rsync --exclude .svn -irplt $WORKDIR/opengnsys/client/engine/*.lib* $INSTALL_TARGET/client/lib/engine/bin
293        if [ $? -ne 0 ]; then
294                errorAndLog "${FUNCNAME}(): error while updating engine files"
295                exit 1
296        fi
297       
298        echoAndLog "${FUNCNAME}(): client files update success."
299}
300
301# Configurar HTTPS y exportar usuario y grupo del servicio Apache.
302function apacheConfiguration ()
303{
304        local APACHECONF=/etc/apache2
305
306        # Activar HTTPS, si es necesario.
307        if [ -e $APACHECONF/sites-available/opengnsys.conf ]; then
308                echoAndLog "${FUNCNAME}(): Configuring HTTPS access..."
309                mv $APACHECONF/sites-available/opengnsys.conf $APACHECONF/sites-available/opengnsys
310                a2ensite default-ssl
311                a2enmod ssl
312                a2ensite opengnsys
313                /etc/init.d/apache2 restart
314        fi
315
316        # Variables de ejecución de Apache.
317        # - APACHE_RUN_USER
318        # - APACHE_RUN_GROUP
319        if [ -f $APACHECONF/envvars ]; then
320                source $APACHECONF/envvars
321        fi
322        APACHE_RUN_USER=${APACHE_RUN_USER:-"www-data"}
323        APACHE_RUN_GROUP=${APACHE_RUN_GROUP:-"www-data"}
324}
325
326# Copiar ficheros del OpenGnSys Web Console.
327function updateWebFiles()
328{
329        local ERRCODE
330        echoAndLog "${FUNCNAME}(): Updating web files..."
331        backupFile $INSTALL_TARGET/www/controlacceso.php
332        mv $INSTALL_TARGET/www $INSTALL_TARGET/WebConsole
333        rsync --exclude .svn -irplt $WORKDIR/opengnsys/admin/WebConsole $INSTALL_TARGET
334        ERRCODE=$?
335        mv $INSTALL_TARGET/WebConsole $INSTALL_TARGET/www
336        unzip -o $WORKDIR/opengnsys/admin/xajax_0.5_standard.zip -d $INSTALL_TARGET/www/xajax
337        if [ $ERRCODE != 0 ]; then
338                errorAndLog "${FUNCNAME}(): Error updating web files."
339                exit 1
340        fi
341        restoreFile $INSTALL_TARGET/www/controlacceso.php
342        # Cambiar permisos para ficheros especiales.
343        chown -R $APACHE_RUN_USER:$APACHE_RUN_GROUP $INSTALL_TARGET/www/includes $INSTALL_TARGET/www/images/iconos
344        echoAndLog "${FUNCNAME}(): Web files updated successfully."
345}
346
347# Copiar carpeta de Interface
348function updateInterfaceAdm()
349{
350        local errcode=0
351         
352        # Crear carpeta y copiar Interface
353        echoAndLog "${FUNCNAME}(): Copying Administration Interface Folder"
354        mv $INSTALL_TARGET/client/interfaceAdm $INSTALL_TARGET/client/Interface
355        rsync --exclude .svn -irplt $WORKDIR/opengnsys/admin/Interface $INSTALL_TARGET/client
356        errcoce=$?
357        mv $INSTALL_TARGET/client/Interface $INSTALL_TARGET/client/interfaceAdm
358        if [ $errcode -ne 0 ]; then
359                echoAndLog "${FUNCNAME}(): error while updating admin interface"
360                exit 1
361        fi
362        chmod -R +x $INSTALL_TARGET/client/interfaceAdm
363        chown $OPENGNSYS_CLIENTUSER:$OPENGNSYS_CLIENTUSER $INSTALL_TARGET/client/interfaceAdm/CambiarAcceso
364        chmod 700 $INSTALL_TARGET/client/interfaceAdm/CambiarAcceso
365        echoAndLog "${FUNCNAME}(): Admin interface updated successfully."
366}
367
368# Crear documentación Doxygen para la consola web.
369function makeDoxygenFiles()
370{
371        echoAndLog "${FUNCNAME}(): Making Doxygen web files..."
372        $WORKDIR/opengnsys/installer/ogGenerateDoc.sh \
373                        $WORKDIR/opengnsys/client/engine $INSTALL_TARGET/www
374        if [ ! -d "$INSTALL_TARGET/www/html" ]; then
375                errorAndLog "${FUNCNAME}(): unable to create Doxygen web files."
376                return 1
377        fi
378        rm -fr "$INSTALL_TARGET/www/api"
379        mv "$INSTALL_TARGET/www/html" "$INSTALL_TARGET/www/api"
380        rm -fr $INSTALL_TARGET/www/{man,perlmod,rtf}
381        chown -R $APACHE_RUN_USER:$APACHE_RUN_GROUP $INSTALL_TARGET/www/api
382        echoAndLog "${FUNCNAME}(): Doxygen web files created successfully."
383}
384
385
386# Crea la estructura base de la instalación de opengnsys
387function createDirs()
388{
389        # Crear estructura de directorios.
390        echoAndLog "${FUNCNAME}(): creating directory paths in ${INSTALL_TARGET}"
391        mkdir -p ${INSTALL_TARGET}/{bin,doc,etc,lib,sbin,www}
392        mkdir -p ${INSTALL_TARGET}/{client,images}
393        mkdir -p ${INSTALL_TARGET}/log/clients
394        ln -fs ${INSTALL_TARGET}/log /var/log/opengnsys
395        ln -fs /var/lib/tftpboot ${INSTALL_TARGET}
396        mkdir -p ${INSTALL_TARGET}/tftpboot/{pxelinux.cfg,menu.lst}
397        if [ $? -ne 0 ]; then
398                errorAndLog "${FUNCNAME}(): error while creating dirs. Do you have write permissions?"
399                return 1
400        fi
401
402        # Crear usuario ficticio.
403        if id -u $OPENGNSYS_CLIENTUSER &>/dev/null; then
404                echoAndLog "${FUNCNAME}(): user \"$OPENGNSYS_CLIENTUSER\" is already created"
405        else
406                echoAndLog "${FUNCNAME}(): creating OpenGnSys user"
407                useradd $OPENGNSYS_CLIENTUSER 2>/dev/null
408                if [ $? -ne 0 ]; then
409                        errorAndLog "${FUNCNAME}(): error creating OpenGnSys user"
410                        return 1
411                fi
412        fi
413
414        # Establecer los permisos básicos.
415        echoAndLog "${FUNCNAME}(): setting directory permissions"
416        chmod -R 775 $INSTALL_TARGET/{log/clients,images,tftpboot/pxelinux.cfg,tftpboot/menu.lst}
417        chown -R :$OPENGNSYS_CLIENTUSER $INSTALL_TARGET/{log/clients,images,tftpboot/pxelinux.cfg,tftpboot/menu.lst}
418        if [ $? -ne 0 ]; then
419                errorAndLog "${FUNCNAME}(): error while setting permissions"
420                return 1
421        fi
422
423        echoAndLog "${FUNCNAME}(): directory paths created"
424        return 0
425}
426
427# Copia ficheros de configuración y ejecutables genéricos del servidor.
428function updateServerFiles()
429{
430        # No copiar ficheros del antiguo cliente Initrd
431        local SOURCES=( repoman/bin \
432                        server/bin \
433                        server/tftpboot \
434                        installer/opengnsys_uninstall.sh \
435                        doc )
436        local TARGETS=( bin \
437                        bin \
438                        tftpboot \
439                        lib/opengnsys_uninstall.sh \
440                        doc )
441
442        if [ ${#SOURCES[@]} != ${#TARGETS[@]} ]; then
443                errorAndLog "${FUNCNAME}(): inconsistent number of array items"
444                exit 1
445        fi
446
447        echoAndLog "${FUNCNAME}(): updating files in server directories"
448        pushd $WORKDIR/opengnsys >/dev/null
449        local i
450        for (( i = 0; i < ${#SOURCES[@]}; i++ )); do
451                if [ -d "$INSTALL_TARGET/${TARGETS[i]}" ]; then
452                        rsync --exclude .svn -irplt "${SOURCES[i]}" $(dirname $(readlink -e "$INSTALL_TARGET/${TARGETS[i]}"))
453                else
454                        rsync --exclude .svn -irplt "${SOURCES[i]}" $(readlink -e "$INSTALL_TARGET/${TARGETS[i]}")
455                fi
456        done
457        popd >/dev/null
458        echoAndLog "${FUNCNAME}(): updating cron files"
459        echo "* * * * *   root   [ -x $INSTALL_TARGET/bin/torrent-creator ] && $INSTALL_TARGET/bin/torrent-creator" > /etc/cron.d/torrentcreator
460        echoAndLog "${FUNCNAME}(): server files updated successfully."
461}
462
463####################################################################
464### Funciones de compilación de código fuente de servicios
465####################################################################
466
467# Recompilar y actualiza los serivicios y clientes.
468function compileServices()
469{
470        local hayErrores=0
471
472        # Compilar OpenGnSys Server
473        echoAndLog "${FUNCNAME}(): Recompiling OpenGnSys Admin Server"
474        pushd $WORKDIR/opengnsys/admin/Sources/Services/ogAdmServer
475        make && mv ogAdmServer $INSTALL_TARGET/sbin
476        if [ $? -ne 0 ]; then
477                echoAndLog "${FUNCNAME}(): error while compiling OpenGnSys Admin Server"
478                hayErrores=1
479        fi
480        popd
481        # Compilar OpenGnSys Repository Manager
482        echoAndLog "${FUNCNAME}(): Recompiling OpenGnSys Repository Manager"
483        pushd $WORKDIR/opengnsys/admin/Sources/Services/ogAdmRepo
484        make && mv ogAdmRepo $INSTALL_TARGET/sbin
485        if [ $? -ne 0 ]; then
486                echoAndLog "${FUNCNAME}(): error while compiling OpenGnSys Repository Manager"
487                hayErrores=1
488        fi
489        popd
490        # Compilar OpenGnSys Agent
491        echoAndLog "${FUNCNAME}(): Recompiling OpenGnSys Agent"
492        pushd $WORKDIR/opengnsys/admin/Sources/Services/ogAdmAgent
493        make && mv ogAdmAgent $INSTALL_TARGET/sbin
494        if [ $? -ne 0 ]; then
495                echoAndLog "${FUNCNAME}(): error while compiling OpenGnSys Agent"
496                hayErrores=1
497        fi
498        popd
499
500        # Compilar OpenGnSys Client
501        echoAndLog "${FUNCNAME}(): Recompiling OpenGnSys Client"
502        pushd $WORKDIR/opengnsys/admin/Sources/Clients/ogAdmClient
503        make && mv ogAdmClient $INSTALL_TARGET/client/bin
504        if [ $? -ne 0 ]; then
505                echoAndLog "${FUNCNAME}(): error while compiling OpenGnSys Client"
506                hayErrores=1
507        fi
508        popd
509
510        return $hayErrores
511}
512
513
514####################################################################
515### Funciones instalacion cliente OpenGnSys
516####################################################################
517
518# Actualizar nuevo cliente para OpenGnSys 1.0
519function updateClient()
520{
521        local DOWNLOADURL="http://www.opengnsys.es/downloads"
522        local FILENAME=ogLive-natty-2.6.38-8-generic-pae-r2303.iso
523        local SOURCEFILE=$DOWNLOADURL/$FILENAME
524        local TARGETFILE=$INSTALL_TARGET/lib/$FILENAME
525        local SOURCELENGTH
526        local TARGETLENGTH
527        local TMPDIR=/tmp/${FILENAME%.iso}
528        local OGINITRD=$INSTALL_TARGET/tftpboot/ogclient/oginitrd.img
529        local SAMBAPASS
530
531        # Comprobar si debe actualizarse el cliente.
532        SOURCELENGTH=$(LANG=C wget --spider $SOURCEFILE 2>&1 | awk '/Length:/ {print $2}')
533        TARGETLENGTH=$(ls -l $TARGETFILE 2>/dev/null | awk '{print $5}')
534        [ -z $TARGETLENGTH ] && TARGETLENGTH=0
535        if [ "$SOURCELENGTH" != "$TARGETLENGTH" ]; then
536                echoAndLog "${FUNCNAME}(): Loading Client"
537                wget $DOWNLOADURL/$FILENAME -O $TARGETFILE
538                if [ ! -s $TARGETFILE ]; then
539                        errorAndLog "${FUNCNAME}(): Error loading OpenGnSys Client"
540                        return 1
541                fi
542                # Obtener la clave actual de acceso a Samba para restaurarla.
543                if [ -f $OGINITRD ]; then
544                        SAMBAPASS=$(gzip -dc $OGINITRD | \
545                                    cpio -i --to-stdout scripts/ogfunctions 2>&1 | \
546                                    grep "^[    ]*OPTIONS=" | \
547                                    sed 's/\(.*\)pass=\(\w*\)\(.*\)/\2/')
548                fi
549                # Montar la imagen ISO del ogclient, actualizar ficheros y desmontar.
550                echoAndLog "${FUNCNAME}(): Updatting ogclient files"
551                mkdir -p $TMPDIR
552                mount -o loop,ro $TARGETFILE $TMPDIR
553                rsync -irlt $TMPDIR/ogclient $INSTALL_TARGET/tftpboot
554                umount $TMPDIR
555                rmdir $TMPDIR
556                # Recuperar la clave de acceso a Samba.
557                if [ -n "$SAMBAPASS" ]; then
558                        echoAndLog "${FUNCNAME}(): Restoring client access key"
559                        echo -ne "$SAMBAPASS\n$SAMBAPASS\n" | \
560                                        $INSTALL_TARGET/bin/setsmbpass
561                fi
562                # Establecer los permisos.
563                find -L $INSTALL_TARGET/tftpboot -type d -exec chmod 755 {} \;
564                find -L $INSTALL_TARGET/tftpboot -type f -exec chmod 644 {} \;
565                chown -R :$OPENGNSYS_CLIENTUSER $INSTALL_TARGET/tftpboot/ogclient
566                chown -R $APACHE_RUN_USER:$APACHE_RUN_GROUP $INSTALL_TARGET/tftpboot/{menu.lst,pxelinux.cfg}
567               
568                cp -prv $INSTALL_TARGET/tftpboot/ogclient/ogvmlinuz* $INSTALL_TARGET/tftpboot/
569                cp -prv $INSTALL_TARGET/tftpboot/ogclient/oginitrd.img* $INSTALL_TARGET/tftpboot/
570               
571                echoAndLog "${FUNCNAME}(): Client update successfully"
572        else
573                echoAndLog "${FUNCNAME}(): Client is already updated"
574        fi
575}
576
577# Resumen de actualización.
578function updateSummary()
579{
580        # Actualizar fichero de versión y revisión.
581        local VERSIONFILE="$INSTALL_TARGET/doc/VERSION.txt"
582        local REVISION=$(LANG=C svn info $SVN_URL|awk '/Revision:/ {print "r"$2}')
583
584        [ -f $VERSIONFILE ] || echo "OpenGnSys" >$VERSIONFILE
585        perl -pi -e "s/($| r[0-9]*)/ $REVISION/" $VERSIONFILE
586
587        echo
588        echoAndLog "OpenGnSys Update Summary"
589        echo       "========================"
590        echoAndLog "Project version:                  $(cat $VERSIONFILE)"
591        echo
592}
593
594
595
596#####################################################################
597####### Proceso de actualización de OpenGnSys
598#####################################################################
599
600
601echoAndLog "OpenGnSys update begins at $(date)"
602
603pushd $WORKDIR
604
605# Comprobar si hay conexión y detectar parámetros de red por defecto.
606checkNetworkConnection
607if [ $? -ne 0 ]; then
608        errorAndLog "Error connecting to server. Causes:"
609        errorAndLog " - Network is unreachable, review devices parameters."
610        errorAndLog " - You are inside a private network, configure the proxy service."
611        errorAndLog " - Server is temporally down, try agian later."
612        exit 1
613fi
614
615# Comprobar auto-actualización del programa.
616if [ "$PROGRAMDIR" != "$INSTALL_TARGET/bin" ]; then
617        checkAutoUpdate
618        if [ $? -ne 0 ]; then
619                echoAndLog "OpenGnSys updater has been overwritten."
620                echoAndLog "Please, re-execute this script."
621                exit
622        fi
623fi
624
625# Instalar dependencias.
626installDependencies $DEPS
627if [ $? -ne 0 ]; then
628        errorAndLog "Error: you may install all needed dependencies."
629        exit 1
630fi
631
632# Arbol de directorios de OpenGnSys.
633createDirs ${INSTALL_TARGET}
634if [ $? -ne 0 ]; then
635        errorAndLog "Error while creating directory paths!"
636        exit 1
637fi
638
639# Si es necesario, descarga el repositorio de código en directorio temporal
640if [ $USESVN -eq 1 ]; then
641        svnExportCode $SVN_URL
642        if [ $? -ne 0 ]; then
643                errorAndLog "Error while getting code from svn"
644                exit 1
645        fi
646else
647        ln -fs "$(dirname $PROGRAMDIR)" opengnsys
648fi
649
650# Si existe fichero de actualización de la base de datos; aplicar cambios.
651INSTVERSION=$(awk '{print $2}' $INSTALL_TARGET/doc/VERSION.txt)
652REPOVERSION=$(awk '{print $2}' $WORKDIR/opengnsys/doc/VERSION.txt)
653OPENGNSYS_DBUPDATEFILE="$WORKDIR/opengnsys/admin/Database/$OPENGNSYS_DATABASE-$INSTVERSION-$REPOVERSION.sql"
654if [ -f $OPENGNSYS_DBUPDATEFILE ]; then
655        echoAndLog "Updating tables from version $INSTVERSION to $REPOVERSION"
656        importSqlFile $OPENGNSYS_DBUSER $OPENGNSYS_DBPASSWORD $OPENGNSYS_DATABASE $OPENGNSYS_DBUPDATEFILE
657else
658        echoAndLog "Database unchanged."
659fi
660
661# Actualizar ficheros complementarios del servidor
662updateServerFiles
663if [ $? -ne 0 ]; then
664        errorAndLog "Error updating OpenGnSys Server files"
665        exit 1
666fi
667
668# Actualizar ficheros del cliente
669updateClientFiles
670updateInterfaceAdm
671
672# Actualizar páqinas web
673apacheConfiguration
674updateWebFiles
675if [ $? -ne 0 ]; then
676        errorAndLog "Error updating OpenGnSys Web Admin files"
677        exit 1
678fi
679# Generar páginas Doxygen para instalar en el web
680makeDoxygenFiles
681
682# Recompilar y actualizar los servicios del sistema
683compileServices
684
685# Actaulizar ficheros auxiliares del cliente
686updateClient
687if [ $? -ne 0 ]; then
688        errorAndLog "Error updating clients"
689        exit 1
690fi
691
692# Actualizamos el fichero que arranca los servicios de OpenGnSys
693updateServicesStart
694
695# Eliminamos el fichero de estado del tracker porque es incompatible entre los distintos paquetes
696if [ -f /tmp/dstate ]; then
697        rm -f /tmp/dstate
698fi
699
700# Mostrar resumen de actualización.
701updateSummary
702
703#rm -rf $WORKDIR
704echoAndLog "OpenGnSys update finished at $(date)"
705
706popd
707
Note: See TracBrowser for help on using the repository browser.